/*
********************************************************************************
* Copyright (2019), Cypress Semiconductor Corporation. All Rights Reserved.
*
*******************************************************************************/

#include "project.h"

#define ENABLE_TUNER (0u)

#define LED_ON (0u)
#define LED_OFF (1u)

void PerformApplication_UpdateLED();

int main()
{
    uint8  guardActive = 0;
    CyGlobalIntEnable;
    
    #if (ENABLE_TUNER)
    EZI2C_Start();
    EZI2C_EzI2CSetBuffer1(sizeof(CapSense_dsRam),sizeof(CapSense_dsRam),(uint8 *)&CapSense_dsRam); 
    #endif
    
    CapSense_Start();
    CapSense_ScanAllWidgets();
     
    for(;;)
    {
        if(CapSense_IsBusy() == CapSense_NOT_BUSY)
        {
                CapSense_ProcessAllWidgets();
                
               #if (ENABLE_TUNER)
                CapSense_RunTuner();
               #endif
  
            /*Check if guard is Active*/
            if(0u == CapSense_IsSensorActive(CapSense_GUARD_WDGT_ID ,CapSense_GUARD_SNS0_ID))
            {
                PerformApplication_UpdateLED();
                CapSense_ScanAllWidgets();       
            }
            else
            {
                /*Initialize the baselines for all the sensors except guard
                 *You can use CapSense_InitializeWidgetBaseline() to Initializes 
                 *(or re-initializes) the baselines of all the sensors in a widget 
                 *specified by the input parameter. 
                */
                CapSense_InitializeSensorBaseline(CapSense_BUTTON_WDGT_ID,CapSense_BUTTON_SNS0_ID);
                
                /*Put pins in default state*/
                Pin_LED_Write(LED_OFF);
                
                /*Scan only guard sensor*/
                CapSense_CSDSetupWidgetExt(CapSense_GUARD_WDGT_ID ,CapSense_GUARD_SNS0_ID);
                CapSense_CSDScanExt();  
            }
        }
    }
}

void PerformApplication_UpdateLED()
{
    if(CapSense_IsSensorActive(CapSense_BUTTON_WDGT_ID,CapSense_BUTTON_SNS0_ID))
            {
                Pin_LED_Write(LED_ON);
            }
            else
            {
                Pin_LED_Write(LED_OFF);
            }
}
   